RECURSIVE_MAKE_ARGS=$(MFLAGS) CC='$(CC)' CFLAGS='$(CFLAGS)' LDFLAGS='$(LDFLAGS)' CPPFLAGS='$(CPPFLAGS)'
SHELL = /bin/sh
LANG = C
LC_ALL = C
RM = rm -f
MAKEPATH=./lib-src/make-path
pwd = /bin/pwd
TAR = tar
CC=gcc
CPP=gcc -E
LN_S=ln -s
CFLAGS=-g -O3 -Wall -Wno-switch -Winline -Wmissing-prototypes -Wsign-compare -fno-strict-aliasing -Wshadow
CPPFLAGS=
LDFLAGS=  
version=21.4.20
configuration=x86_64-unknown-linux
PROGNAME=xemacs
prefix=~/xemacs
inststaticdir=${PROGNAME}
instvardir=${PROGNAME}-${version}
exec_prefix=${prefix}
bindir=${exec_prefix}/bin
datadir=${prefix}/lib
pkgdir=${datadir}/${instvardir}/lisp
statedir=${prefix}/lib
libdir=${exec_prefix}/lib
mandir=${prefix}/man/man1
manext=.1
infodir=${datadir}/${instvardir}/info
infopath=
srcdir=/user/owzarm/XEMACS/xemacs-21.4.20
blddir=/user/owzarm/XEMACS/xemacs-21.4.20
lispdir=${datadir}/${instvardir}/lisp
moduledir=${libdir}/${instvardir}/${configuration}/modules
sitelispdir=${datadir}/${inststaticdir}/site-lisp
sitemoduledir=${libdir}/${inststaticdir}/site-modules
buildlispdir=${srcdir}/lisp
etcdir=${datadir}/${instvardir}/etc
docdir=${archlibdir}
archlibdir=${libdir}/${instvardir}/${configuration}
INSTALL =  /usr/bin/install -c
INSTALL_PROGRAM = ${INSTALL}
INSTALL_DATA = ${INSTALL} -m 644
MAKE_SUBDIR =  lib-src lwlib src
SUBDIR = ${MAKE_SUBDIR} man  
SUBDIR_DISTCLEAN = ${SUBDIR} modules/sample modules/ldap modules/zlib modules/base64
SUBDIR_MAKEFILES = lib-src/Makefile lib-src/GNUmakefile lwlib/Makefile lwlib/GNUmakefile src/Makefile src/GNUmakefile
INSTALL_ARCH_DEP_SUBDIR =  lib-src src
COPYDIR = ${srcdir}/etc ${srcdir}/lisp
COPYDESTS = ${etcdir} ${lispdir}
GENERATED_HEADERS = src/paths.h src/Emacs.ad.h src/config.h lwlib/config.h src/sheap-adjust.h
GENERATED_LISP = lisp/finder-inf.el
all: ${PROGNAME} all-elc info
${PROGNAME}:	${GENERATED_HEADERS} ${MAKE_SUBDIR} ${GENERATED_LISP}
.SUFFIXES:
.NO_PARALLEL:	${GENERATED_HEADERS} ${MAKE_SUBDIR} dump-elcs
.PHONY: ${SUBDIR} all beta all-elc all-elcs dump-elc dump-elcs autoloads finder
beta: clean all-elc finder info
dist: all-elc info
.PHONY: config configure depend
config: configure depend
configure: ${srcdir}/configure ${srcdir}/lib-src/config.values.in
${srcdir}/configure : ${srcdir}/configure.in
	cd ${srcdir} && autoconf
${srcdir}/lib-src/config.values.in : ${srcdir}/configure
	cd ${srcdir} && $(SHELL) lib-src/config.values.sh
depend ${srcdir}/src/depend:
	cd ./src && $(MAKE) $(RECURSIVE_MAKE_ARGS) depend
all-elc all-elcs: ${PROGNAME} autoloads dump-elcs
	${blddir}/src/${PROGNAME} -batch -vanilla \
		-l update-elc-2.el -f batch-update-elc-2 lisp
dump-elc dump-elcs: ${PROGNAME} ${GENERATED_HEADERS} FRC.dump-elcs
	cd ./src && $(MAKE) $(RECURSIVE_MAKE_ARGS) dump-elcs
autoloads: lib-src lwlib src lisp/auto-autoloads.el lisp/custom-load.el
FRC.lisp.auto.autoloads.el:
lisp/auto-autoloads.el:	${PROGNAME} FRC.lisp.auto.autoloads.el
	$(RM) lisp/auto-autoloads.el
	${blddir}/src/${PROGNAME} -batch -no-autoloads \
		-l autoload -f batch-update-directory lisp
	${blddir}/src/${PROGNAME} -batch -vanilla \
		-f batch-byte-compile lisp/auto-autoloads.el
	@$(RM) lisp/auto-autoloads.el~
FRC.lisp.custom.load.el:
lisp/custom-load.el: ${PROGNAME} FRC.lisp.custom.load.el lisp/auto-autoloads.el
	${blddir}/src/${PROGNAME} -batch -vanilla -l cus-dep \
		-f Custom-make-dependencies lisp
finder: src
	@echo "Building finder database ..."
	$(RM) lisp/finder-inf.el
	@(cd ./lisp; \
		${blddir}/src/${PROGNAME} -batch -vanilla \
		-eval '(setq finder-compile-keywords-quiet t)' \
		-l finder -f finder-compile-keywords )
	@echo "Building finder database ...(done)"
lisp/finder-inf.el: src
	@echo "Building finder database ..."
	@(cd ./lisp; \
		${blddir}/src/${PROGNAME} -batch -vanilla \
		-eval '(setq finder-compile-keywords-quiet t)' \
		-l finder -f finder-compile-keywords )
	@echo "Building finder database ...(done)"
src/Emacs.ad.h: ${srcdir}/etc/Emacs.ad
	@echo "Producing \`src/Emacs.ad.h' from \`etc/Emacs.ad'."
	@$(RM) src/Emacs.ad.h
	@(echo "/*	Do not edit this file!" ; \
	  echo "  	Automatically generated from ${srcdir}/etc/Emacs.ad" ; \
	  echo " */" ; \
	  $(SHELL) ${srcdir}/lib-src/ad2c ${srcdir}/etc/Emacs.ad ) > \
	  src/Emacs.ad.h
src/sheap-adjust.h:
	@echo "Resetting \`src/sheap-adjust.h'."; \
	(echo "/*	Do not edit this file!" ; \
	 echo "  	Automatically generated by XEmacs */" ; \
	 echo "#define SHEAP_ADJUSTMENT 0") > $@
src:  lwlib FRC.src
pkg-src/tree-x: pkg-src/FRC.tree-x
lib-src: FRC.lib-src
lwlib:	FRC.lwlib
dynodump: FRC.dynodump
FRC.src FRC.lib-src FRC.lwlib FRC.dynodump pkg-src/FRC.tree-x:
FRC.lisp.finder-inf.el:
${SUBDIR}: ${SUBDIR_MAKEFILES} ${GENERATED_HEADERS} FRC
	cd ./$@ && $(MAKE) $(RECURSIVE_MAKE_ARGS) all
modules/sample modules/ldap modules/zlib modules/base64: lib-src
Makefile: ${srcdir}/Makefile.in.in config.status
	./config.status
src/Makefile: ${srcdir}/src/Makefile.in.in ${srcdir}/src/depend config.status
	./config.status
lib-src/Makefile: ${srcdir}/lib-src/Makefile.in.in config.status
	./config.status
lwlib/Makefile: ${srcdir}/lwlib/Makefile.in.in config.status
	./config.status
pkg-src/tree-x/Makefile: ${srcdir}/pkg-src/tree-x/Makefile.in.in config.status
	./config.status
src/config.h: ${srcdir}/src/config.h.in
	./config.status && touch $@
src/paths.h: ${srcdir}/src/paths.h.in
	./config.status && touch $@
lwlib/config.h: ${srcdir}/lwlib/config.h.in
	./config.status && touch $@
.PHONY: install-only install install-arch-dep install-arch-indep gzip.el mkdir
.PHONY: check-features
check-features: all
	${blddir}/src/${PROGNAME} -batch -l check-features.el
install-only: ${MAKE_SUBDIR} check-features install-arch-dep install-arch-indep
install: all check-features install-arch-dep install-arch-indep
install-arch-dep: mkdir
	for subdir in ${INSTALL_ARCH_DEP_SUBDIR}; do \
	(cd ./$${subdir} && $(MAKE) $(RECURSIVE_MAKE_ARGS) install prefix=${prefix} \
	    exec_prefix=${exec_prefix} bindir=${bindir} libdir=${libdir} \
	    archlibdir=${archlibdir}) ; done
	if test "`(cd ${archlibdir} && $(pwd))`" != \
		"`(cd ./lib-src && $(pwd))`"; then \
	   if test -f ../Installation; then \
		${INSTALL_DATA} ../Installation ${archlibdir}/Installation; \
	   fi; \
	   ${INSTALL_DATA} lib-src/config.values ${docdir}/config.values; \
	   ${INSTALL_DATA} lib-src/DOC ${docdir}/DOC; \
	   for subdir in `find ${archlibdir} -type d ! -name RCS ! -name SCCS ! -name CVS -print` ; \
	     do (cd $${subdir} && $(RM) -r RCS CVS SCCS \#* *~) ; done ; \
	else true; fi
	${INSTALL_DATA} src/${PROGNAME}.dmp ${bindir}/${PROGNAME}-${version}-`src/${PROGNAME} -sd`.dmp
	${INSTALL_PROGRAM} src/${PROGNAME} ${bindir}/${PROGNAME}-${version}
	-chmod 0755 ${bindir}/${PROGNAME}-${version}
	cd ${bindir} && $(RM) ./${PROGNAME} && ${LN_S} ${PROGNAME}-${version} ./${PROGNAME}
	if test "${prefix}" != "${exec_prefix}"; then \
	  $(MAKEPATH) ${exec_prefix}/lib/${instvardir}; \
	  for dir in \
		lib/${inststaticdir} \
	 	lib/${instvardir}/etc \
		lib/${instvardir}/info \
		lib/${instvardir}/lisp; do \
	    if test ! -d ${exec_prefix}/$${dir}; then \
	      $(LN_S) ${prefix}/$${dir} ${exec_prefix}/$${dir}; fi; \
	  done; \
	fi
install-arch-indep: mkdir info
	-@set ${COPYDESTS} ; \
	 for dir in ${COPYDIR} ; do \
	   if test "`(cd $$1 && $(pwd))`" != \
		   "`(cd $${dir} && $(pwd))`"; then \
	     : do nothing - echo "rm -rf $$1" ; \
	   fi ; \
	   shift ; \
	 done
	-set ${COPYDESTS} ; \
	 for dir in ${COPYDESTS} ; do \
	   if test ! -d $${dir} ; then mkdir $${dir} ; fi ; \
	 done ; \
	 for dir in ${COPYDIR} ; do \
	   dest=$$1 ; shift ; \
	   test -d $${dir} \
	     -a "`(cd $${dir} && $(pwd))`" != \
		"`(cd $${dest} && $(pwd))`" \
	   && (echo "Copying $${dir}..." ; \
	       (cd $${dir} && $(TAR) -cf - . ) | \
		(cd $${dest} && umask 022 && $(TAR) -xf - );\
	       chmod 0755 $${dest}; \
	       for subdir in `find $${dest} -type d ! -name RCS ! -name SCCS ! -name CVS -print` ; do \
		 (cd $${subdir} && $(RM) -r RCS CVS SCCS \#* *~) ; \
	       done) ; \
	 done
	if test "`(cd ${srcdir}/info && $(pwd))`" != \
		"`(cd ${infodir} && $(pwd))`" && cd ${srcdir}/info; then \
	  if test ! -f ${infodir}/dir -a -f dir ; then \
	    ${INSTALL_DATA} ${srcdir}/info/dir ${infodir}/dir ; \
	  fi ; \
	  for file in *.info* ; do \
	    ${INSTALL_DATA} $${file} ${infodir}/$${file} ; \
	    chmod 0644 ${infodir}/$${file}; \
	  done ; \
	fi
	cd ${srcdir}/etc && \
	  for page in xemacs etags ctags gnuserv gnuclient gnuattach gnudoit; do \
	    ${INSTALL_DATA} ${srcdir}/etc/$${page}.1 ${mandir}/$${page}${manext} ; \
	    chmod 0644 ${mandir}/$${page}${manext} ; \
	  done
	@echo "If you would like to save approximately 2M of disk space, do"
	@echo "make gzip-el"
	@echo "or you may run "
	@echo ${srcdir}/lib-src/gzip-el.sh lispdir " from the command line."
	@echo "Where lispdir is where the lisp files were installed, i.e.,"
	@echo "${lispdir}"
gzip-el:
	$(SHELL) ${srcdir}/lib-src/gzip-el.sh ${lispdir}
mkdir: FRC.mkdir
	${MAKEPATH} ${COPYDESTS} ${docdir} ${infodir} ${archlibdir} \
	  ${mandir} ${bindir} ${datadir} ${libdir} ${pkgdir} \
	  ${sitelispdir} ${moduledir} ${sitemoduledir}
FRC FRC.src.paths.h FRC.mkdir FRC.dump-elcs FRC.info:
FRC.mostlyclean FRC.clean FRC.distclean FRC.realclean FRC.tags:
.PHONY: mostlyclean clean distclean realclean extraclean
mostlyclean: FRC.mostlyclean
	for d in $(SUBDIR); do (cd ./$$d && $(MAKE) $(RECURSIVE_MAKE_ARGS) $@); done
clean: FRC.clean
	for d in $(SUBDIR); do (cd ./$$d && $(MAKE) $(RECURSIVE_MAKE_ARGS) $@); done
	$(RM) core
top_distclean=\
	$(RM) config.status config.log confdefs.h config-tmp-* build-install Installation ; \
	$(RM) core .sbinit lock/* GNUmakefile Makefile Makefile.in ; \
	$(RM) lisp/finder-inf.el* Installation.el Installation.elc ; \
	$(RM) -r site-packages xemacs-packages mule-packages site-lisp
distclean: FRC.distclean
	for d in $(SUBDIR_DISTCLEAN); do (cd ./$$d && $(MAKE) $(RECURSIVE_MAKE_ARGS) $@); done
	-${top_distclean}
realclean: FRC.realclean
	for d in $(SUBDIR); do (cd ./$$d && $(MAKE) $(RECURSIVE_MAKE_ARGS) $@); done
	-${top_distclean}
	$(RM) TAGS
extraclean:
	for d in $(SUBDIR); do (cd ./$$d && $(MAKE) $(RECURSIVE_MAKE_ARGS) $@); done
	$(RM) *~ \#*
	-${top_distclean}
SOURCES = ChangeLog GETTING.GNU.SOFTWARE INSTALL Makefile.in PROBLEMS \
	README build-install.in configure make-dist move-if-change
.PHONY: unlock relock TAGS tags check dist info dvi mcs
unlock:
	chmod u+w $(SOURCES) cpp/*
	-cd ./elisp && chmod u+w Makefile README *.texi
	for d in src etc lib-src lisp; do (cd ./$$d && $(MAKE) $(RECURSIVE_MAKE_ARGS) $@); done
	cd ./lisp/term && chmod u+w README *.el
	cd ./man && chmod u+w *texi* ChangeLog split-man
	cd ./lwlib && chmod u+w *.[ch] Makefile.in.in
relock:
	chmod u-w $(SOURCES) cpp/*
	-cd ./elisp && chmod u-w Makefile README *.texi
	for d in src etc lib-src lisp; do (cd ./$$d && $(MAKE) $(RECURSIVE_MAKE_ARGS) $@); done
	cd ./lisp/term && chmod u+w README *.el
	cd ./man && chmod u+w *texi* ChangeLog split-man
	cd ./lwlib && chmod u+w *.[ch] Makefile.in.in
PRUNE_VC = -name SCCS -prune -o -name RCS -prune -o -name CVS -prune -o
tagslisp = lisp
TAGS tags: FRC.tags
	@echo "If you don't have a copy of etags around, then do 'make lib-src' first."
	$(RM) ${srcdir}/TAGS
	@PATH=`$(pwd)`/lib-src:$$PATH HOME=/-=-; export PATH HOME; \
	  echo "Using etags from `which etags`."
	PATH=`$(pwd)`/lib-src:$$PATH ; export PATH; cd ${srcdir} && \
	find src lwlib lib-src ${PRUNE_VC} -name '*.[ch]' -print | \
	  xargs etags -a -r '/[ 	]*DEF\(VAR\|INE\)_[A-Z_]+[ 	]*([ 	]*"\([^"]+\)"/\2/'; \
	find ${tagslisp} ${PRUNE_VC} -name '*.el' ! -name 'auto-autoloads.el' -print | \
	  xargs etags -a -l none -r "/^(def\\(var\\|un\\|alias\\|const\\|macro\\|subst\\|struct\\|face\\|group\\|custom\\|ine-\\(function\\|compiler-macro\\|[a-z-]+alias\\)\\)[ 	]+'?\\([^ 	]+\\)/\\3/"
check:
	cd ./src && $(MAKE) $(RECURSIVE_MAKE_ARGS) $@
info: FRC.info
	cd ${srcdir}/man && $(MAKE) $(RECURSIVE_MAKE_ARGS) $@
dvi:
	cd ${srcdir}/man && $(MAKE) $(RECURSIVE_MAKE_ARGS) $@
mcs:
	date=`LANG=C LC_ALL=C date -u '+%e %b %Y'`; \
	ident="@(#)RELEASE VERSION XEmacs ${version} $${date}"; \
	for f in `file lib-src/* src/${PROGNAME} | grep ELF | sed -e 's/:.*//'`; do \
	  mcs -da "$${ident} `echo $${f} | sed 's/.*\///'`" $${f}; \
	done
